# std::basic_string< _CharT, _Traits, _Alloc > Class Template Reference
[Strings, Sequences]

Managing sequences of characters and character-like objects. More...

Inheritance diagram for std::basic_string< _CharT, _Traits, _Alloc >:
[legend]

List of all members.

## Public Types

- typedef _Alloc allocator_type
- typedef
  __gnu_cxx::__normal_iterator
  < const_pointer, basic_string > const_iterator
- typedef
  _CharT_alloc_type::const_pointer const_pointer
- typedef
  _CharT_alloc_type::const_reference const_reference
- typedef std::reverse_iterator
  < const_iterator > const_reverse_iterator
- typedef
  _CharT_alloc_type::difference_type difference_type
- typedef
  __gnu_cxx::__normal_iterator
  < pointer, basic_string > iterator
- typedef _CharT_alloc_type::pointer pointer
- typedef
  _CharT_alloc_type::reference reference
- typedef std::reverse_iterator
  < iterator > reverse_iterator
- typedef
  _CharT_alloc_type::size_type size_type
- typedef _Traits traits_type
- typedef _Traits::char_type value_type

## Public Member Functions

- basic_string ()
- basic_string (const _Alloc &__a)
- basic_string (const basic_string &__str, size_type __pos, size_type __n=npos)
- basic_string (size_type __n, _CharT __c, const _Alloc &__a=_Alloc())
- basic_string (basic_string &&__str)
- basic_string (const basic_string &__str, size_type __pos, size_type __n, const _Alloc &__a)
- basic_string (initializer_list< _CharT > __l, const _Alloc &__a=_Alloc())
- template<class _InputIterator > basic_string (_InputIterator __beg, _InputIterator __end, const _Alloc &__a=_Alloc())
- basic_string (const basic_string &__str)
- basic_string (const _CharT *__s, size_type __n, const _Alloc &__a=_Alloc())
- basic_string (const _CharT *__s, const _Alloc &__a=_Alloc())
- ~basic_string ()
- template<typename _InIterator > _CharT * _S_construct (_InIterator __beg, _InIterator __end, const _Alloc &__a, forward_iterator_tag)
- basic_string & append (const basic_string &__str)
- basic_string & append (const basic_string &__str, size_type __pos, size_type __n)
- basic_string & append (const _CharT *__s, size_type __n)
- basic_string & append (const _CharT *__s)
- basic_string & append (size_type __n, _CharT __c)
- basic_string & append (initializer_list< _CharT > __l)
- template<class _InputIterator > basic_string & append (_InputIterator __first, _InputIterator __last)
- basic_string & assign (initializer_list< _CharT > __l)
- basic_string & assign (const basic_string &__str)
- basic_string & assign (basic_string &&__str)
- basic_string & assign (const basic_string &__str, size_type __pos, size_type __n)
- basic_string & assign (const _CharT *__s, size_type __n)
- basic_string & assign (size_type __n, _CharT __c)
- basic_string & assign (const _CharT *__s)
- template<class _InputIterator > basic_string & assign (_InputIterator __first, _InputIterator __last)
- const_reference at (size_type __n) const
- reference at (size_type __n)
- iterator begin ()
- const_iterator begin () const
- const _CharT * c_str () const
- size_type capacity () const
- const_iterator cbegin () const
- const_iterator cend () const
- void clear ()
- int compare (size_type __pos, size_type __n1, const _CharT *__s) const
- int compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
- int compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2) const
- int compare (const basic_string &__str) const
- int compare (size_type __pos, size_type __n, const basic_string &__str) const
- int compare (const _CharT *__s) const
- size_type copy (_CharT *__s, size_type __n, size_type __pos=0) const
- const_reverse_iterator crbegin () const
- const_reverse_iterator crend () const
- const _CharT * data () const
- bool empty () const
- iterator end ()
- const_iterator end () const
- basic_string & erase (size_type __pos=0, size_type __n=npos)
- iterator erase (iterator __position)
- iterator erase (iterator __first, iterator __last)
- size_type find (_CharT __c, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find (const basic_string &__str, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos=0) const
- size_type find_first_not_of (_CharT __c, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_not_of (const basic_string &__str, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_of (const basic_string &__str, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_of (_CharT __c, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos=npos) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_not_of (const basic_string &__str, size_type __pos=npos) const
- size_type find_last_not_of (_CharT __c, size_type __pos=npos) const
- size_type find_last_of (const basic_string &__str, size_type __pos=npos) const
- size_type find_last_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_of (const _CharT *__s, size_type __pos=npos) const
- size_type find_last_of (_CharT __c, size_type __pos=npos) const
- allocator_type get_allocator () const
- void insert (iterator __p, size_type __n, _CharT __c)
- template<class _InputIterator > void insert (iterator __p, _InputIterator __beg, _InputIterator __end)
- void insert (iterator __p, initializer_list< _CharT > __l)
- basic_string & insert (size_type __pos1, const basic_string &__str)
- basic_string & insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
- basic_string & insert (size_type __pos, const _CharT *__s, size_type __n)
- basic_string & insert (size_type __pos, const _CharT *__s)
- iterator insert (iterator __p, _CharT __c)
- basic_string & insert (size_type __pos, size_type __n, _CharT __c)
- size_type length () const
- size_type max_size () const
- basic_string & operator+= (const _CharT *__s)
- basic_string & operator+= (const basic_string &__str)
- basic_string & operator+= (_CharT __c)
- basic_string & operator+= (initializer_list< _CharT > __l)
- basic_string & operator= (const _CharT *__s)
- basic_string & operator= (_CharT __c)
- basic_string & operator= (basic_string &&__str)
- basic_string & operator= (initializer_list< _CharT > __l)
- basic_string & operator= (const basic_string &__str)
- reference operator[] (size_type __pos)
- const_reference operator[] (size_type __pos) const
- void push_back (_CharT __c)
- reverse_iterator rbegin ()
- const_reverse_iterator rbegin () const
- reverse_iterator rend ()
- const_reverse_iterator rend () const
- basic_string & replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
- basic_string & replace (size_type __pos, size_type __n1, const _CharT *__s)
- basic_string & replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
- basic_string & replace (iterator __i1, iterator __i2, initializer_list< _CharT > __l)
- basic_string & replace (size_type __pos, size_type __n, const basic_string &__str)
- basic_string & replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
- basic_string & replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
- template<class _InputIterator > basic_string & replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
- basic_string & replace (iterator __i1, iterator __i2, const basic_string &__str)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__s)
- basic_string & replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
- basic_string & replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
- basic_string & replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
- void reserve (size_type __res_arg=0)
- void resize (size_type __n)
- void resize (size_type __n, _CharT __c)
- size_type rfind (_CharT __c, size_type __pos=npos) const
- size_type rfind (const _CharT *__s, size_type __pos, size_type __n) const
- size_type rfind (const _CharT *__s, size_type __pos=npos) const
- size_type rfind (const basic_string &__str, size_type __pos=npos) const
- void shrink_to_fit ()
- size_type size () const
- basic_string substr (size_type __pos=0, size_type __n=npos) const
- void swap (basic_string &__s)

## Static Public Attributes

- static const size_type npos

## Detailed Description

### template<typename _CharT, typename _Traits, typename _Alloc>
class std::basic_string< _CharT, _Traits, _Alloc >

Managing sequences of characters and character-like objects.

Meets the requirements of a container, a reversible container, and a sequence. Of the optional sequence requirements, only `push_back`, `at`, and `array` access are supported.

Todo:
  Doc me! See doc/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Documentation? What's that? Nathan Myers <ncm@cantrip.org>.

A string looks like this:

                                            [_Rep]
                                            _M_length
       [basic_string<char_type>]            _M_capacity
       _M_dataplus                          _M_refcount
       _M_p ---------------->               unnamed array of char_type

Where the _M_p points to the first character in the string, and you cast it to a pointer-to-_Rep and subtract 1 to get a pointer to the header.

This approach has the enormous advantage that a string object requires only one allocation. All the ugliness is confined within a single pair of inline functions, which each compile to a single add instruction: _Rep::_M_data(), and string::_M_rep(); and the allocation function which gets a block of raw bytes and with room enough and constructs a _Rep object at the front.

The reason you want _M_data pointing to the character array and not the _Rep is so that the debugger can see the string contents. (Probably we should add a non-inline member to get the _Rep for the debugger to use, so users can check the actual string length.)

Note that the _Rep object is a POD so that you can have a static empty string _Rep object already constructed before static constructors have run. The reference-count encoding is chosen so that a 0 indicates one reference, so you never try to destroy the empty-string _Rep object.

All but the last paragraph is considered pretty conventional for a C++ string implementation.

Definition at line 105 of file basic_string.h.

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( |  | ) | `[inline]`

Default constructor creates an empty string.

Definition at line 423 of file basic_string.h.

template<typename _CharT , typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _Alloc & | __a | ) | `[explicit]`

Construct an empty string using allocator a.

Definition at line 178 of file basic_string.tcc.

template<typename _CharT , typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

Construct string with copy of value of str.

Parameters:

  | str | Source string.

Definition at line 170 of file basic_string.tcc.

template<typename _CharT , typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n = `npos` |
| ) |  |  |

Construct string as copy of a substring.

Parameters:

  | str | Source string.
  | pos | Index of first character to copy from.
  | n | Number of characters to copy (default remainder).

Definition at line 184 of file basic_string.tcc.

template<typename _CharT , typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n,
|  | const _Alloc & | __a |
| ) |  |  |

Construct string as copy of a substring.

Parameters:

  | str | Source string.
  | pos | Index of first character to copy from.
  | n | Number of characters to copy.
  | a | Allocator to use.

Definition at line 194 of file basic_string.tcc.

template<typename _CharT, typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _CharT * | __s,
|  | size_type | __n,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  |

Construct string initialized by a character array.

Parameters:

  | s | Source character array.
  | n | Number of characters to copy.
  | a | Allocator to use (default is default allocator).

NB: s must have at least n characters, '\0' has no special meaning.

Definition at line 206 of file basic_string.tcc.

template<typename _CharT, typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _CharT * | __s,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  |

Construct string as copy of a C string.

Parameters:

  | s | Source C string.
  | a | Allocator to use (default is default allocator).

Definition at line 213 of file basic_string.tcc.

template<typename _CharT, typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | size_type | __n,
|  | _CharT | __c,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  |

Construct string as multiple characters.

Parameters:

  | n | Number of characters.
  | c | Character to use.
  | a | Allocator to use (default is default allocator).

Definition at line 220 of file basic_string.tcc.

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) | `[inline]`

Move construct string.

Parameters:

  | str | Source string.

The newly-created string contains the exact contents of str. str is a valid, but unspecified string.

Definition at line 493 of file basic_string.h.

template<typename _CharT, typename _Traits , typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | initializer_list< _CharT > | __l,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  |

Construct string from an initializer list.

Parameters:

  | l | std::initializer_list of characters.
  | a | Allocator to use (default is default allocator).

Definition at line 235 of file basic_string.tcc.

template<typename _CharT , typename _Traits , typename _Alloc>
template<typename _InputIterator >

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | _InputIterator | __beg,
|  | _InputIterator | __end,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  |

Construct string as copy of a range.

Parameters:

  | beg | Start of range.
  | end | End of range.
  | a | Allocator to use (default is default allocator).

Definition at line 228 of file basic_string.tcc.

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::~basic_string | ( |  | ) | `[inline]`

Destroy the string instance.

Definition at line 524 of file basic_string.h.

## Member Function Documentation

template<typename _CharT , typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  |

Append a substring.

Parameters:

  | str | The string to append.
  | pos | Index of the first character of str to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function appends n characters from str starting at pos to this string. If n is is larger than the number of available characters in str, the remainder of str is appended.

Definition at line 342 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::capacity(), std::basic_string< _CharT, _Traits, _Alloc >::reserve(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  |

Append a C substring.

Parameters:

  | s | The C string to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

Definition at line 298 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::capacity(), std::basic_string< _CharT, _Traits, _Alloc >::reserve(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const _CharT * | __s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Definition at line 954 of file basic_string.h.

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  |

Append multiple characters.

Parameters:

  | n | The number of characters to append.
  | c | The character to use.

Returns:
  Reference to this string.

Appends n copies of c to this string.

Definition at line 281 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::capacity(), std::basic_string< _CharT, _Traits, _Alloc >::reserve(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::append | ( | initializer_list< _CharT > | __l | ) | `[inline]`

Append an initializer_list of characters.

Parameters:

  | l | The initializer_list of characters to append.

Returns:
  Reference to this string.

Definition at line 978 of file basic_string.h.

Referenced by std::basic_string< char >::append().

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator >

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::append | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Append a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Appends characters in the range [first,last) to this string.

Definition at line 992 of file basic_string.h.

template<typename _CharT , typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Definition at line 325 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::capacity(), std::basic_string< _CharT, _Traits, _Alloc >::reserve(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by std::collate< _CharT >::do_transform(), std::operator+(), std::operator>>(), and std::basic_string< _CharT, _Traits, _Alloc >::resize().

template<typename _CharT , typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

Set value to contents of another string.

Parameters:

  | str | Source string to use.

Returns:
  Reference to this string.

Definition at line 243 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::get_allocator().

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::str().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) | `[inline]`

Set value to contents of another string.

Parameters:

  | str | Source string to use.

Returns:
  Reference to this string.

This function sets this string to the exact contents of str. str is a valid, but unspecified string.

Definition at line 1027 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | `[inline]`

Set value to a substring of a string.

Parameters:

  | str | The string to use.
  | pos | Index of the first character of str.
  | n | Number of characters to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of str consisting of n characters at pos. If n is is larger than the number of available characters in str, the remainder of str is used.

Definition at line 1047 of file basic_string.h.

Referenced by std::basic_string< char >::assign().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  |

Set value to a C substring.

Parameters:

  | s | The C string to use.
  | n | Number of characters to use.

Returns:
  Reference to this string.

This function sets the value of this string to the first n characters of s. If n is is larger than the number of available characters in s, the remainder of s is used.

Definition at line 259 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Set value to multiple characters.

Parameters:

  | n | Length of the resulting string.
  | c | The character to use.

Returns:
  Reference to this string.

This function sets the value of this string to n copies of character c.

Definition at line 1091 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator >

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Set value to a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Sets value of string to characters in the range [first,last).

Definition at line 1104 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | initializer_list< _CharT > | __l | ) | `[inline]`

Set value to an initializer_list of characters.

Parameters:

  | l | The initializer_list of characters to assign.

Returns:
  Reference to this string.

Definition at line 1114 of file basic_string.h.

Referenced by std::basic_string< char >::assign().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const _CharT * | __s | ) | `[inline]`

Set value to contents of a C string.

Parameters:

  | s | The C string to use.

Returns:
  Reference to this string.

This function sets the value of this string to the value of s. The data is copied, so there is no dependence on s once the function returns.

Definition at line 1075 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read-only (const) reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 847 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read/write reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 866 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first character in the string. Unshares the string.

Definition at line 591 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 602 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const _CharT* std::basic_string< _CharT, _Traits, _Alloc >::c_str | ( |  | ) | const`[inline]`

Return const pointer to null-terminated contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 1723 of file basic_string.h.

Referenced by std::collate< _CharT >::do_compare(), std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::collate< _CharT >::do_transform(), and std::basic_filebuf< char_type, traits_type >::open().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::capacity | ( |  | ) | const`[inline]`

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 759 of file basic_string.h.

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::append(), and std::basic_string< _CharT, _Traits, _Alloc >::reserve().

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::cbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 666 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::cend | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 674 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::clear | ( |  | ) | `[inline]`

Erases the string, making it empty.

Definition at line 786 of file basic_string.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::setbuf().

template<typename _CharT, typename _Traits , typename _Alloc >

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 |
| ) |  |  | const

Compare substring against a character array.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | character array to compare against.
  | n2 | Number of characters of s.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form a string from the first n2 characters of s. Returns an integer < 0 if this substring is ordered before the string from s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '\0' has no special meaning.

Definition at line 980 of file basic_string.tcc.

References std::min().

template<typename _CharT , typename _Traits , typename _Alloc >

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 |
| ) |  |  | const

Compare substring to a substring.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | str | String to compare against.
  | pos2 | Index of first character of substring of str.
  | n2 | Number of characters in substring of str.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form the substring of str from the n2 characters starting at pos2. Returns an integer < 0 if this substring is ordered before the substring of str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 931 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::compare(), std::basic_string< _CharT, _Traits, _Alloc >::data(), and std::min().

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) | const`[inline]`

Compare to a string.

Parameters:

  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before str, 0 if their values are equivalent, or > 0 if this string is ordered after str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 2130 of file basic_string.h.

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::compare(), std::operator<(), std::operator<=(), std::operator==(), std::operator>(), and std::operator>=().

template<typename _CharT , typename _Traits , typename _Alloc >

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str |
| ) |  |  | const

Compare substring to a string.

Parameters:

  | pos | Index of first character of substring.
  | n | Number of characters in substring.
  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n characters starting at pos. Returns an integer < 0 if the substring is ordered before str, 0 if their values are equivalent, or > 0 if the substring is ordered after str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 916 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::compare(), std::basic_string< _CharT, _Traits, _Alloc >::data(), std::min(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits , typename _Alloc >

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | const _CharT * | __s | ) | const

Compare to a C string.

Parameters:

  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before s, 0 if their values are equivalent, or > 0 if this string is ordered after s. Determines the effective length rlen of the strings to compare as the smallest of size() and the length of a string constructed from s. The function then compares the two strings by calling traits::compare(data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 949 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::compare(), std::basic_string< _CharT, _Traits, _Alloc >::length(), std::min(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits , typename _Alloc >

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s |
| ) |  |  | const

Compare substring to a C string.

Parameters:

  | pos | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before s, 0 if their values are equivalent, or > 0 if the substring is ordered after s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and the length of a string constructed from s. The function then compares the two string by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 964 of file basic_string.tcc.

References std::min().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::copy | ( | _CharT * | __s,
|  | size_type | __n,
|  | size_type | __pos = `0` |
| ) |  |  | const

Copy substring into C string.

Parameters:

  | s | C string to copy value into.
  | n | Number of characters to copy.
  | pos | Index of first character to copy.

Returns:
  Number of characters actually copied

Exceptions:

  | std::out_of_range | If pos > size().

Copies up to n characters starting at pos into the C string s. If pos is greater than size(), out_of_range is thrown.

Definition at line 723 of file basic_string.tcc.

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::crbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 683 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::crend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 692 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const _CharT* std::basic_string< _CharT, _Traits, _Alloc >::data | ( |  | ) | const`[inline]`

Return const pointer to contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 1733 of file basic_string.h.

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::compare(), std::basic_string< char >::compare(), std::collate< _CharT >::do_compare(), std::collate< _CharT >::do_transform(), std::basic_string< char >::find(), std::basic_string< char >::find_first_not_of(), std::basic_string< char >::find_first_of(), std::basic_string< char >::find_last_not_of(), std::basic_string< char >::find_last_of(), std::basic_string< char >::rfind(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::str().

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::empty | ( |  | ) | const`[inline]`

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 794 of file basic_string.h.

Referenced by std::operator>>().

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last character in the string. Unshares the string.

Definition at line 610 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 621 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | size_type | __pos = `0`,
|  | size_type | __n = `npos` |
| ) |  |  | `[inline]`

Remove characters.

Parameters:

  | pos | Index of first character to remove (default 0).
  | n | Number of characters to remove (default remainder).

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.

Removes n characters from this string starting at pos. The length of the string is reduced by n. If there are < n characters to remove, the remainder of the string is truncated. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1304 of file basic_string.h.

Referenced by std::getline(), std::operator>>(), and std::basic_string< _CharT, _Traits, _Alloc >::resize().

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | iterator | __position | ) | `[inline]`

Remove one character.

Parameters:

  | position | Iterator referencing the character to remove.

Returns:
  iterator referencing same location after removal.

Removes the character at position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1320 of file basic_string.h.

template<typename _CharT , typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  |

Remove a range of characters.

Parameters:

  | first | Iterator referencing the first character to remove.
  | last | Iterator referencing the end of the range.

Returns:
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 391 of file basic_string.tcc.

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 737 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::find(), and std::basic_string< _CharT, _Traits, _Alloc >::find_first_of().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1768 of file basic_string.h.

Referenced by std::basic_string< char >::find().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1782 of file basic_string.h.

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 760 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::find(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const

Find position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 864 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1992 of file basic_string.h.

Referenced by std::basic_string< char >::find_first_not_of().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from.
  | n | Number of characters from s to consider.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 852 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2021 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1870 of file basic_string.h.

Referenced by std::basic_string< char >::find_first_of().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find position of a character of C substring.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from.
  | n | Number of characters from s to search for.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 816 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::find(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character of C string.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1898 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for the character c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(c, pos).

Definition at line 1917 of file basic_string.h.

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const

Find last position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 896 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2051 of file basic_string.h.

Referenced by std::basic_string< char >::find_last_not_of().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find last position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search back from.
  | n | Number of characters from s to consider.

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 875 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2080 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1931 of file basic_string.h.

Referenced by std::basic_string< char >::find_last_of().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find last position of a character of C substring.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from.
  | n | Number of characters from s to search for.

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 831 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character of C string.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1959 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(c, pos).

Definition at line 1978 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

allocator_type std::basic_string< _CharT, _Traits, _Alloc >::get_allocator | ( |  | ) | const`[inline]`

Return copy of allocator used to construct this string.

Definition at line 1740 of file basic_string.h.

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::assign(), std::basic_string< _CharT, _Traits, _Alloc >::reserve(), and std::basic_string< _CharT, _Traits, _Alloc >::swap().

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Insert multiple characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts n copies of character c starting at the position referenced by iterator p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1131 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator >

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end |
| ) |  |  | `[inline]`

Insert a range of characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | beg | Start of range.
  | end | End of range.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [beg,end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1147 of file basic_string.h.

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  |

Insert a C substring.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.
  | n | The number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 360 of file basic_string.tcc.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Insert multiple characters.

Parameters:

  | pos | Index in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts n copies of character c starting at index pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos > length(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1263 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | initializer_list< _CharT > | __l |
| ) |  |  | `[inline]`

Insert an initializer_list of characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | l | The initializer_list of characters to insert.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Definition at line 1158 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str |
| ) |  |  | `[inline]`

Insert value of a string.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts value of str starting at pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1177 of file basic_string.h.

Referenced by std::basic_string< char >::insert().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n |
| ) |  |  | `[inline]`

Insert a substring.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.
  | pos2 | Start of characters in str to insert.
  | n | Number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos1 > size() or pos2 > str.size().

Starting at pos1, insert n character of str beginning with pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos1 is beyond the end of this string or pos2 is beyond the end of str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1199 of file basic_string.h.

Referenced by std::basic_string< char >::insert().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s |
| ) |  |  | `[inline]`

Insert a C string.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1240 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Insert one character.

Parameters:

  | p | Iterator referencing position in string to insert at.
  | c | The character to insert.

Returns:
  Iterator referencing newly inserted char.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts character c at position referenced by p. If adding character causes the length to exceed max_size(), length_error is thrown. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1280 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::length | ( |  | ) | const`[inline]`

Returns the number of characters in the string, not including any /// null-termination.

Definition at line 707 of file basic_string.h.

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::compare(), std::collate< _CharT >::do_compare(), and std::collate< _CharT >::do_transform().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::max_size | ( |  | ) | const`[inline]`

Returns the size() of the largest possible string.

Definition at line 712 of file basic_string.h.

Referenced by std::getline(), and std::operator>>().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) | `[inline]`

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Definition at line 881 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | const _CharT * | __s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Definition at line 890 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | _CharT | __c | ) | `[inline]`

Append a character.

Parameters:

  | c | The character to append.

Returns:
  Reference to this string.

Definition at line 899 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | initializer_list< _CharT > | __l | ) | `[inline]`

Append an initializer_list of characters.

Parameters:

  | l | The initializer_list of characters to be appended.

Returns:
  Reference to this string.

Definition at line 912 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) | `[inline]`

Move assign the value of str to this string.

Parameters:

  | str | Source string.

The contents of str are moved into this string (without copying). str is a valid, but unspecified string.

Definition at line 566 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | initializer_list< _CharT > | __l | ) | `[inline]`

Set value to string constructed from initializer list.

Parameters:

  | l | std::initializer_list.

Definition at line 578 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | const _CharT * | __s | ) | `[inline]`

Copy contents of s into this string.

Parameters:

  | s | Source null-terminated string.

Definition at line 540 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) | `[inline]`

Assign the value of str to this string.

Parameters:

  | str | Source string.

Definition at line 532 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | _CharT | __c | ) | `[inline]`

Set value to string of length 1.

Parameters:

  | c | Source character.

Assigning to a character makes this string length 1 and (*this)[0] == c.

Definition at line 551 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) | const`[inline]`

Subscript access to the data contained in the string.

Parameters:

  | pos | The index of the character to access.

Returns:
  Read-only (constant) reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 809 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) | `[inline]`

Subscript access to the data contained in the string.

Parameters:

  | pos | The index of the character to access.

Returns:
  Read/write reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().) Unshares the string.

Definition at line 826 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::push_back | ( | _CharT | __c | ) | `[inline]`

Append a single character.

Parameters:

  | c | Character to append.

Definition at line 1000 of file basic_string.h.

Referenced by std::collate< _CharT >::do_transform(), and std::operator>>().

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 639 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rbegin | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to the last character in the string. Iteration is done in reverse element order. Unshares the string.

Definition at line 630 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rend | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order. Unshares the string.

Definition at line 648 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 657 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | initializer_list< _CharT > | __l |
| ) |  |  | `[inline]`

Replace range of characters with initializer_list.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | l | The initializer_list of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, characters in the range [k1,k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1616 of file basic_string.h.

Referenced by std::basic_string< char >::replace().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str |
| ) |  |  | `[inline]`

Replace range of characters with string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | str | String value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the value of str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1465 of file basic_string.h.

Referenced by std::basic_string< char >::replace().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | size_type | __n2,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Replace characters with multiple characters.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | n2 | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, n2 copies of c are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1447 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Replace range of characters with multiple characters.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | n | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, n copies of c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1525 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator >

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2 |
| ) |  |  | `[inline]`

Replace range of characters with range.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | k1 | Iterator referencing start of range to insert.
  | k2 | Iterator referencing end of range to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, characters in the range [k1,k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1548 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 |
| ) |  |  | `[inline]`

Replace characters with value from another string.

Parameters:

  | pos1 | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | str | String to insert.
  | pos2 | Index of first character of str to use.
  | n2 | Number of characters from str to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size() or pos2 > str.size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos1,pos1 + n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1381 of file basic_string.h.

Referenced by std::basic_string< char >::replace().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s |
| ) |  |  | `[inline]`

Replace characters with value of a C string.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | s | C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the characters of s are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1424 of file basic_string.h.

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 |
| ) |  |  |

Replace characters with value of a C substring.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | s | C string to insert.
  | n2 | Number of characters from s to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the first n2 characters of s are inserted, or all of s if n2 is too large. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 414 of file basic_string.tcc.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s |
| ) |  |  | `[inline]`

Replace range of characters with C string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1504 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str |
| ) |  |  | `[inline]`

Replace characters with value from another string.

Parameters:

  | pos | Index of first character to replace.
  | n | Number of characters to be replaced.
  | str | String to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos+n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1359 of file basic_string.h.

Referenced by std::basic_string< char >::replace().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string& std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inline]`

Replace range of characters with C substring.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.
  | n | Number of characters from s to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the first n characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1483 of file basic_string.h.

template<typename _CharT , typename _Traits , typename _Alloc >

void std::basic_string< _CharT, _Traits, _Alloc >::reserve | ( | size_type | __res_arg = `0` | ) |

Attempt to preallocate enough memory for specified number of characters.

Parameters:

  | res_arg | Number of characters required.

Exceptions:

  | std::length_error | If res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 502 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::capacity(), std::basic_string< _CharT, _Traits, _Alloc >::get_allocator(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::append(), std::num_get< _CharT, _InIter >::do_get(), and std::operator>>().

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n | ) | `[inline]`

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.

This function will resize the string to the specified length. If the new size is smaller than the string's current size the string is truncated, otherwise the string is extended and new characters are default-constructed. For basic types such as char, this means setting them to 0.

Definition at line 739 of file basic_string.h.

Referenced by std::basic_string< char >::resize().

template<typename _CharT, typename _Traits , typename _Alloc >

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  |

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.
  | c | Character to fill any new elements.

This function will resize the string to the specified number of characters. If the number is smaller than the string's current size the string is truncated, otherwise the string is extended and new elements are set to c.

Definition at line 640 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::append(), std::basic_string< _CharT, _Traits, _Alloc >::erase(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by std::money_get< _CharT, _InIter >::do_get().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1812 of file basic_string.h.

Referenced by std::basic_string< char >::rfind().

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to start search at (default end).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1840 of file basic_string.h.

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 799 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits , typename _Alloc >

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find last position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search back from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 778 of file basic_string.tcc.

References std::min(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::shrink_to_fit | ( |  | ) | `[inline]`

A non-binding request to reduce capacity() to size().

Definition at line 745 of file basic_string.h.

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::size | ( |  | ) | const`[inline]`

Returns the number of characters in the string, not including any /// null-termination.

Definition at line 701 of file basic_string.h.

Referenced by std::basic_string< _CharT, _Traits, _Alloc >::append(), std::basic_string< _CharT, _Traits, _Alloc >::assign(), std::bitset< _Nb >::bitset(), std::basic_string< _CharT, _Traits, _Alloc >::compare(), std::basic_string< char >::compare(), std::basic_string< _CharT, _Traits, _Alloc >::find(), std::basic_string< char >::find(), std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of(), std::basic_string< char >::find_first_not_of(), std::basic_string< _CharT, _Traits, _Alloc >::find_first_of(), std::basic_string< char >::find_first_of(), std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of(), std::basic_string< char >::find_last_not_of(), std::basic_string< _CharT, _Traits, _Alloc >::find_last_of(), std::basic_string< char >::find_last_of(), std::basic_string< char >::insert(), std::operator+(), std::basic_string< char >::replace(), std::basic_string< _CharT, _Traits, _Alloc >::reserve(), std::basic_string< _CharT, _Traits, _Alloc >::resize(), std::basic_string< _CharT, _Traits, _Alloc >::rfind(), std::basic_string< char >::rfind(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::str().

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string std::basic_string< _CharT, _Traits, _Alloc >::substr | ( | size_type | __pos = `0`,
|  | size_type | __n = `npos` |
| ) |  |  | const`[inline]`

Get a substring.

Parameters:

  | pos | Index of first character (default 0).
  | n | Number of characters in substring (default remainder).

Returns:
  The new string.

Exceptions:

  | std::out_of_range | If pos > size().

Construct and return a new string using the n characters starting at pos. If the string is too short, use the remainder of the characters. If pos is beyond the end of the string, out_of_range is thrown.

Definition at line 2112 of file basic_string.h.

template<typename _CharT , typename _Traits , typename _Alloc >

void std::basic_string< _CharT, _Traits, _Alloc >::swap | ( | basic_string< _CharT, _Traits, _Alloc > & | __s | ) |

Swap contents with another string.

Parameters:

  | s | String to swap with.

Exchanges the contents of this string with that of s in constant time.

Definition at line 519 of file basic_string.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::get_allocator().

Referenced by std::swap().

## Member Data Documentation

template<typename _CharT, typename _Traits, typename _Alloc>

const basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::npos `[static]`

Value returned by various member functions when they fail.

Definition at line 271 of file basic_string.h.

The documentation for this class was generated from the following files:

- basic_string.h
- basic_string.tcc